
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ContractsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contracts = await db.contracts.create(
            {
                id: data.id || undefined,
        
        contract_number: data.contract_number
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        start_date: data.start_date
        ||
        null
            ,
            
        end_date: data.end_date
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await contracts.setBusiness( data.business || null, {
            transaction,
        });
        
        await contracts.setCounterparty( data.counterparty || null, {
            transaction,
        });
        
        await contracts.setCurrency( data.currency || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.contracts.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: contracts.id,
            },
            data.attachments,
            options,
        );
        

        return contracts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const contractsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                contract_number: item.contract_number
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                start_date: item.start_date
            ||
            null
            ,
            
                end_date: item.end_date
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const contracts = await db.contracts.bulkCreate(contractsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < contracts.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.contracts.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: contracts[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return contracts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const contracts = await db.contracts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.contract_number !== undefined) updatePayload.contract_number = data.contract_number;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.start_date !== undefined) updatePayload.start_date = data.start_date;
        
        
        if (data.end_date !== undefined) updatePayload.end_date = data.end_date;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await contracts.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await contracts.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        
        if (data.counterparty !== undefined) {
            await contracts.setCounterparty(
              
              data.counterparty,
              
              { transaction }
            );
        }
        
        if (data.currency !== undefined) {
            await contracts.setCurrency(
              
              data.currency,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.contracts.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: contracts.id,
            },
            data.attachments,
            options,
        );
        

        return contracts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contracts = await db.contracts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of contracts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of contracts) {
                await record.destroy({transaction});
            }
        });


        return contracts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const contracts = await db.contracts.findByPk(id, options);

        await contracts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await contracts.destroy({
            transaction
        });

        return contracts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const contracts = await db.contracts.findOne(
            { where },
            { transaction },
        );

        if (!contracts) {
            return contracts;
        }

        const output = contracts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.journal_lines_contract = await contracts.getJournal_lines_contract({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await contracts.getBusiness({
            transaction
        });
        
        
        output.counterparty = await contracts.getCounterparty({
            transaction
        });
        
        
        output.currency = await contracts.getCurrency({
            transaction
        });
        
        
        output.attachments = await contracts.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              trade_name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.counterparties,
        as: 'counterparty',
        
        where: filter.counterparty ? {
          [Op.or]: [
            { id: { [Op.in]: filter.counterparty.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.counterparty.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.currencies,
        as: 'currency',
        
        where: filter.currency ? {
          [Op.or]: [
            { id: { [Op.in]: filter.currency.split('|').map(term => Utils.uuid(term)) } },
            {
              code: {
                [Op.or]: filter.currency.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.contract_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contracts',
                        'contract_number',
                        filter.contract_number,
                    ),
                };
            }
            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contracts',
                        'title',
                        filter.title,
                    ),
                };
            }
            

            
            

            
            if (filter.start_dateRange) {
                const [start, end] = filter.start_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    start_date: {
                    ...where.start_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    start_date: {
                    ...where.start_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.end_dateRange) {
                const [start, end] = filter.end_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    end_date: {
                    ...where.end_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    end_date: {
                    ...where.end_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.contracts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'contracts',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.contracts.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

